from strutils import isEmptyOrWhitespace
from httpclient import HttpCode

type ApiError* = object of CatchableError
  respMsg*: string
  respCode*: HttpCode

proc newApiError*(parent: ref Exception = nil, respCode: HttpCode, respMsg: string, msg = ""): ref ApiError =
  result = newException(ApiError, msg, parent)
  result.respCode = respCode
  result.respMsg = respMsg

proc raiseApiError*(respCode: HttpCode, respMsg: string, msg = "") =
  var apiError = newApiError(
    parent = nil,
    respCode = respCode,
    respMsg = respMsg,
    msg = if msg.isEmptyOrWhitespace: respMsg
          else: msg)
  raise apiError

proc raiseApiError*(parent: ref Exception, respCode: HttpCode, respMsg: string, msg = "") =
  var apiError = newApiError(
    parent = parent,
    respCode = respCode,
    respMsg = respMsg,
    msg = msg)
  raise apiError
