## JSON parsing utils
import json, times, timeutils, uuids

const MONTH_FORMAT* = "YYYY-MM"

proc getOrFail*(n: JsonNode, key: string): JsonNode =
  ## convenience method to get a key from a JObject or raise an exception
  if not n.hasKey(key):
    raise newException(ValueError, "missing key '" & key & "'")

  return n[key]

proc parseUUID*(n: JsonNode, key: string): UUID =
  return parseUUID(n.getOrFail(key).getStr)

proc parseIso8601*(n: JsonNode, key: string): DateTime =
  return parseIso8601(n.getOrFail(key).getStr)

proc parseMonth*(n: JsonNode, key: string): DateTime =
  return parse(n.getOrFail(key).getStr, MONTH_FORMAT)

proc formatMonth*(dt: DateTime): string =
  return dt.format(MONTH_FORMAT)
